<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Interactive Spike Generator</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/three.js/r128/three.min.js"></script>
    <style>
        #spike-container {
            width: 400px;
            height: 400px;
            margin: 20px;
        }
        .slider {
            width: 400px;
        }
        .value-display {
            display: inline-block;
            width: 50px;
        }
    </style>
</head>
<body>
    <div id="spike-container"></div>
    <!-- Height slider with range adjusted to 1 to 1.5 -->
    Height: <input type="range" id="height-slider" class="slider" min="1" max="1.5" step="0.01" value="1">
    <span id="height-display" class="value-display">1</span><br>
    <!-- Width slider with max value set to 1/10th of its original -->
    Width: <input type="range" id="width-slider" class="slider" min="0.01" max="0.1" step="0.01" value="0.05">
    <span id="width-display" class="value-display">0.25</span><br>
    Color: <input type="color" id="color-picker" value="#ff0000"><br>
    Opacity: <input type="range" id="opacity-slider" class="slider" min="0" max="1" step="0.01" value="1">
    <span id="opacity-display" class="value-display">1.00</span><br>

<script>
    let scene = new THREE.Scene();
    scene.background = new THREE.Color(0xFFFFFF); // Set the background to white
    let camera = new THREE.PerspectiveCamera(75, window.innerWidth/window.innerHeight, 0.1, 1000);
    let renderer = new THREE.WebGLRenderer({antialias: true});
    renderer.setClearColor(0xffffff, 1); // Also set renderer clear color to white
    renderer.setSize(400, 400);
    document.getElementById('spike-container').appendChild(renderer.domElement);

    let geometry = new THREE.CylinderGeometry(2.5, 2.5, 5, 32);
    let material = new THREE.MeshBasicMaterial({color: 0xff0000, transparent: true, opacity: 1});
    let cylinder = new THREE.Mesh(geometry, material);
    scene.add(cylinder);

    camera.position.z = 15;

    let animate = function () {
        requestAnimationFrame(animate);
        renderer.render(scene, camera);
    };

    animate();
    // Event listener for height slider
    document.getElementById('height-slider').addEventListener('input', function(event) {
        cylinder.scale.y = event.target.value;
        document.getElementById('height-display').textContent = event.target.value;
    });
    // Event listener for width slider
    document.getElementById('width-slider').addEventListener('input', function(event) {
        let scaleValue = event.target.value / 0.25; // Adjust scale based on the new max value
        cylinder.scale.x = cylinder.scale.z = scaleValue;
        document.getElementById('width-display').textContent = event.target.value;
    });

    document.getElementById('color-picker').addEventListener('input', function(event) {
        cylinder.material.color.set(event.target.value);
    });

    document.getElementById('opacity-slider').addEventListener('input', function(event) {
        cylinder.material.opacity = event.target.value;
        document.getElementById('opacity-display').textContent = parseFloat(event.target.value).toFixed(2);
    });
</script>
</body>
</html>
